/**
 * The following class is just a wrapper to the sps2 utility functions that
 * handle the screen.
 * If you need more control over the display than is provided by this class
 * you may want to consider using screen_template.cpp/h as a template from
 * which to create your own display handling code.
 */
#include <sps2util.h>
#include "screen.h"

void CScreen::ScreenSetup(int iSuppressSignalHandlers) {
  sps2UScreenInit(iSuppressSignalHandlers);
}

void CScreen::Swap() {
  sps2UScreenSwap();
  sps2UScreenClear(0x10, 0x10, 0x20);
}

uint32 CScreen::GetFirstFreeGsPage() {
  return sps2UScreenGetFirstFreeGSPage();
}

uint32 CScreen::GetDrawFptr() {
  return sps2UScreenGetDrawBuffCurrent();
}

uint32 CScreen::GetZptr() {
  return sps2UScreenGetZPtr();
}

uint32 CScreen::GetDrawBuff1() {
  return sps2UScreenGetDrawBuff1();
}

uint32 CScreen::GetDrawBuff2() {
  return sps2UScreenGetDrawBuff2();
}

uint32 CScreen::GetWidth() {
  return sps2UScreenGetWidth();
}

uint32 CScreen::GetHeight() {
  return sps2UScreenGetHeight();
}

uint32 CScreen::GetDepth() {
  return sps2UScreenGetZDepth();
}

uint32 CScreen::GetMode() {
  return sps2UScreenGetVideoMode();
}

CScreen::CScreen() {
}

CScreen::~CScreen() {
  sps2UScreenShutdown();
}
