#include "imeshinstance.h"
#include "macro_codes.h"
#include "imesh.h"
#include <math.h>
#include "p2lassert.h"
#include "stitchhack.h"


void IMeshInstance::Draw(Mat44 m, Mat44 ToScr)
{
	for(int a=0; a<8; a++)
	{
		memcpy(m_pLocToWorld[a], (void *) &m.m_fMat[(a>>1)*4+((a&1)<<1)], 8);
		memcpy(m_pWorldToScreen[a], (void *) &ToScr.m_fMat[(a>>1)*4+((a&1)<<1)], 8);
	}
	asm("sync.l");
}

void IMeshInstance::InitDMA_List()
{
	InitChain(m_pDmaVif1, STCYCL(1,1));
	AddWordToChain(m_pDmaVif1, UNPACK(V4_32, 8, PAD_CHUNK+1));	

	// clear space for, LocalToWorld and WorldToScreen
	for(int a=0; a<4; a++)
	{
		// beware of TTE/NewTag discontinuence
		m_pLocToWorld[a*2+0] = AddWordToChain(m_pDmaVif1, 0);
		AddWordToChain(m_pDmaVif1, 0);
		m_pLocToWorld[a*2+1] = AddWordToChain(m_pDmaVif1, 0);
		AddWordToChain(m_pDmaVif1, 0);
	}

	for(int a=0; a<4; a++)
	{
		// beware of TTE/NewTag discontinuence
		m_pWorldToScreen[a*2+0] = AddWordToChain(m_pDmaVif1, 0);
		AddWordToChain(m_pDmaVif1, 0);
		m_pWorldToScreen[a*2+1] = AddWordToChain(m_pDmaVif1, 0);
		AddWordToChain(m_pDmaVif1, 0);
	}
	
	// Terminate (add a ret_tag)
	Terminate(m_pDmaVif1);	
}



                                      
IMeshInstance::IMeshInstance(IMesh * pMotherMesh, CDmaVif1 * pDmaVif1)
{
	m_pMotherMesh = pMotherMesh;
	m_pDmaVif1 = (CDmaVif1 *) malloc(sizeof(CDmaVif1));
	*m_pDmaVif1 = *pDmaVif1;
	m_pDmaVif1->Reset();
	m_pDmaTags = m_pDmaVif1->GetCurLocation();

	InitDMA_List();

	m_iNumClipPlanes = 0;
}

