/**
 * This test/demo tests writing to the VU memory using DMA/VIF and
 * reading the data by mapping the VU memory directly.
 */
#include <stdio.h>
#include "packet.h"
#include "sps2lib.h"

int main() {
  // writing "0x12345678 0x98765432 0x12346789 0x98764321" to the first and last qw of vu1mem
  
  // vif packet
  vifpacket_t vpkt;
  sps2Memory_t *pDescriptor;
  int iSPS2Device;
  
  iSPS2Device=sps2Init();
  pDescriptor=sps2Allocate(4096, SPS2_MAP_BLOCK_4K, iSPS2Device);
  
  // init vif packet
  vifpacket_init(&vpkt, pDescriptor->pvStart);
  
  // add "end" tag
  vifpacket_end(&vpkt, 0);
  
  // add "unpack" to write at the start of vu1mem
  vifpacket_openupkcode( &vpkt, 0, V4_32, 4, 4 );
  
  // add data
  vifpacket_adddata(&vpkt, 0x12345678);
  vifpacket_adddata(&vpkt, 0x98765432);
  vifpacket_adddata(&vpkt, 0x12346789);
  vifpacket_adddata(&vpkt, 0x98764321);
  
  // close "unpack"
  vifpacket_closeupkcode(&vpkt);
  
  vifpacket_terminate(&vpkt);

  sps2FlushCache(iSPS2Device);

  *EE_D1_TADR=sps2GetPhysicalAddress(vpkt.base, pDescriptor);
  *EE_D1_CHCR= 1 | (1<<2) | (1<<8);
  
  sps2WaitForDMA(1, iSPS2Device);

  printf("Beginning of vu memory is\n\t%08x %08x %08x %08x\n\t%08x %08x %08x %08x\n",
	 VU1_MEM[0],
	 VU1_MEM[1],
	 VU1_MEM[2],
	 VU1_MEM[3],
	 VU1_MEM[4],
	 VU1_MEM[5],
	 VU1_MEM[6],
	 VU1_MEM[7]);

  return 0;
}

